diff --git a/exts/omni.replicator.isaac/omni/replicator/isaac/ogn/python/nodes/OgnPose.py b/exts/omni.replicator.isaac/omni/replicator/isaac/ogn/python/nodes/OgnPose.py
index 7ae7051cf..390f6b303 100644
--- a/exts/omni.replicator.isaac/omni/replicator/isaac/ogn/python/nodes/OgnPose.py
+++ b/exts/omni.replicator.isaac/omni/replicator/isaac/ogn/python/nodes/OgnPose.py
@@ -10,7 +10,7 @@ import json
 
 import numpy as np
 import omni.graph.core as og
-from omni.isaac.core.utils.transformations import tf_matrix_from_pose
+from omni.isaac.core.utils.transformations import tf_matrix_from_pose, pose_from_tf_matrix
 from omni.isaac.core.utils.rotations import euler_angles_to_quat
 
 from omni.replicator.isaac.scripts.utils import get_image_space_points
@@ -31,6 +31,10 @@ class OgnPose:
             center_type = ("center_coords_image_space", "<f4", (2,))
             return_data_list.append(center_type)
 
+        # AA Hack
+        rotation_type = ("rotation", "<f4", (4,))
+        return_data_list.append(rotation_type)
+
         return_data_dtype = np.dtype(return_data_list)
 
         required_semantic_types = db.inputs.semanticTypes
@@ -171,6 +175,12 @@ class OgnPose:
 
         prims_to_desired_camera = default_camera_to_desired_camera @ world_to_default_camera @ prims_to_world
 
+        # AA Hack
+        rotations = []
+        for prim_to_desired_camera in prims_to_desired_camera:
+            location, rotation = pose_from_tf_matrix(prim_to_desired_camera)
+            rotations.append(rotation)
+
         # Centers
         if get_centers:
             prim_translations = prims_to_world[:, :-1, -1]
@@ -198,6 +208,10 @@ class OgnPose:
         if get_centers:
             data["center_coords_image_space"] = centers
 
+        # AA Hack
+        if len(rotations) > 0:
+            data["rotation"] = np.array(rotations, dtype=np.dtype([("rotation", "<f4", (4,))]))
+
         db.outputs.data = np.frombuffer(data.tobytes(), dtype=np.uint8)
         db.outputs.idToLabels = serialized_index_to_labels
         db.outputs.primPaths = prim_paths
diff --git a/exts/omni.replicator.isaac/omni/replicator/isaac/scripts/writers/ycb_video_writer.py b/exts/omni.replicator.isaac/omni/replicator/isaac/scripts/writers/ycb_video_writer.py
index 25873e809..b4db67a2d 100644
--- a/exts/omni.replicator.isaac/omni/replicator/isaac/scripts/writers/ycb_video_writer.py
+++ b/exts/omni.replicator.isaac/omni/replicator/isaac/scripts/writers/ycb_video_writer.py
@@ -17,6 +17,7 @@ from PIL import Image
 from omni.replicator.core import AnnotatorRegistry, BackendDispatch, Writer, WriterRegistry
 from omni.syntheticdata import SyntheticData
 from omni.isaac.core.utils.mesh import get_mesh_vertices_relative_to
+from omni.isaac.core.utils.rotations import quat_to_rot_matrix
 
 NodeTemplate, NodeConnectionTemplate = SyntheticData.NodeTemplate, SyntheticData.NodeConnectionTemplate
 
@@ -342,7 +343,7 @@ class YCBVideoWriter(Writer):
         cls_indexes = []
         centers = []
 
-        for i, (semantic_id, pose, center) in enumerate(pose_data):
+        for i, (semantic_id, pose, center, rotations) in enumerate(pose_data):
 
             # Class indexes
             semantic_labels = id_to_labels[str(semantic_id)]["class"]
@@ -353,6 +354,10 @@ class YCBVideoWriter(Writer):
             # Poses
             transform_matrices[i, ...] = pose
 
+            # AA Hack
+            assert n == 1, "Error. Unsupported. Fix this to support more than 1 target object."
+            transform_matrices[0,:3,:3] = quat_to_rot_matrix(rotations)
+
             # Centers
             centers.append([center[0], center[1]])
 
diff --git a/standalone_examples/replicator/offline_pose_generation/offline_pose_cube.py b/standalone_examples/replicator/offline_pose_generation/offline_pose_cube.py
index 1f7408dee..323d09a9c 100644
--- a/standalone_examples/replicator/offline_pose_generation/offline_pose_cube.py
+++ b/standalone_examples/replicator/offline_pose_generation/offline_pose_cube.py
@@ -464,6 +464,7 @@ class RandomScenario(torch.utils.data.IterableDataset):
                         ("semanticId", "<u4"),
                         ("prims_to_desired_camera", "<f4", (4, 4)),
                         ("center_coords_image_space", "<f4", (2,)),
+                        ("rotation", "<f4", (4,)),  # Quaternion
                     ]
                 ),
                 output_is_2d=False,