---
 .../tegra210-porg-gpio-p3448-0002-b00.dtsi         |  6 +----
 .../tegra210-porg-pinmux-p3448-0002-b00.dtsi       |  8 +++----
 .../kernel-dts/tegra210-porg-p3448-common.dtsi     | 28 ++++++++++++++++++----
 3 files changed, 29 insertions(+), 13 deletions(-)

diff --git a/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-gpio-p3448-0002-b00.dtsi b/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-gpio-p3448-0002-b00.dtsi
index ac8bda8..650b165 100644
--- a/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-gpio-p3448-0002-b00.dtsi
+++ b/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-gpio-p3448-0002-b00.dtsi
@@ -27,10 +27,6 @@
 		gpio_default: default {
 			gpio-input = <
 				TEGRA_GPIO(BB, 0)
-				TEGRA_GPIO(B, 4)
-				TEGRA_GPIO(B, 5)
-				TEGRA_GPIO(B, 6)
-				TEGRA_GPIO(B, 7)
 				TEGRA_GPIO(DD, 0)
 				TEGRA_GPIO(E, 6)
 				TEGRA_GPIO(S, 5)
@@ -58,6 +54,7 @@
 				TEGRA_GPIO(H, 2)
 				TEGRA_GPIO(H, 5)
 				TEGRA_GPIO(H, 6)
+				TEGRA_GPIO(I, 0)
 				TEGRA_GPIO(CC, 4)
 				>;
 			gpio-output-low = <
@@ -67,7 +64,6 @@
 				TEGRA_GPIO(H, 3)
 				TEGRA_GPIO(H, 4)
 				TEGRA_GPIO(H, 7)
-				TEGRA_GPIO(I, 0)
 				TEGRA_GPIO(I, 2)
 				>;
 			gpio-output-high = <
diff --git a/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-pinmux-p3448-0002-b00.dtsi b/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-pinmux-p3448-0002-b00.dtsi
index 60e5bb4..109a069 100644
--- a/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-pinmux-p3448-0002-b00.dtsi
+++ b/hardware/nvidia/platform/t210/porg/kernel-dts/porg-platforms/tegra210-porg-pinmux-p3448-0002-b00.dtsi
@@ -505,7 +505,7 @@
 
 			spi2_mosi_pb4 {
 				nvidia,pins = "spi2_mosi_pb4";
-				nvidia,function = "rsvd2";
+				nvidia,function = "spi2";
 				nvidia,pull = <TEGRA_PIN_PULL_DOWN>;
 				nvidia,tristate = <TEGRA_PIN_DISABLE>;
 				nvidia,enable-input = <TEGRA_PIN_ENABLE>;
@@ -513,7 +513,7 @@
 
 			spi2_miso_pb5 {
 				nvidia,pins = "spi2_miso_pb5";
-				nvidia,function = "rsvd2";
+				nvidia,function = "spi2";
 				nvidia,pull = <TEGRA_PIN_PULL_DOWN>;
 				nvidia,tristate = <TEGRA_PIN_DISABLE>;
 				nvidia,enable-input = <TEGRA_PIN_ENABLE>;
@@ -521,7 +521,7 @@
 
 			spi2_sck_pb6 {
 				nvidia,pins = "spi2_sck_pb6";
-				nvidia,function = "rsvd2";
+				nvidia,function = "spi2";
 				nvidia,pull = <TEGRA_PIN_PULL_DOWN>;
 				nvidia,tristate = <TEGRA_PIN_DISABLE>;
 				nvidia,enable-input = <TEGRA_PIN_ENABLE>;
@@ -529,7 +529,7 @@
 
 			spi2_cs0_pb7 {
 				nvidia,pins = "spi2_cs0_pb7";
-				nvidia,function = "rsvd2";
+				nvidia,function = "spi2";
 				nvidia,pull = <TEGRA_PIN_PULL_DOWN>;
 				nvidia,tristate = <TEGRA_PIN_DISABLE>;
 				nvidia,enable-input = <TEGRA_PIN_ENABLE>;
diff --git a/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-porg-p3448-common.dtsi b/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-porg-p3448-common.dtsi
index 57cb90c..dcb2ac9 100644
--- a/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-porg-p3448-common.dtsi
+++ b/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-porg-p3448-common.dtsi
@@ -205,8 +205,17 @@
 		};
 	};
 
+	can_clock: can_clock{
+		phandle = <0x12c>;
+		linux,phandle = <0x12c>;
+		compatible = "fixed-clock";
+		#clock-cells = <0>;
+		clock-frequency = <8000000>;
+		clock-accuracy = <100>;
+	};
+
 	spi@7000d400 { /* SPI 1 to 40 pin header */
-		status = "okay";
+		status = "disabled";
 		spi@0 {
 			compatible = "spidev";
 			reg = <0x0>;
@@ -229,13 +238,24 @@
 
 	spi@7000d600 { /* SPI 2 to 40 pin header */
 		status = "okay";
+		num-cs = <1>;
+		cs-gpios = <&gpio TEGRA_GPIO(B, 7) GPIO_ACTIVE_LOW>;
 		spi@0 {
-			compatible = "spidev";
+			status = "okay";
+			compatible = "microchip,mcp2515";
 			reg = <0x0>;
-			spi-max-frequency = <33000000>;
+			clocks = <&can_clock>;
+			interrupt-parent = <&gpio>;
+			interrupts = <TEGRA_GPIO(I, 0) 0x01>;
+			vdd-supply = <&battery_reg>;
+			xceiver-supply = <&battery_reg>;
+			spi-max-frequency = <10000000>;
 			controller-data {
 				nvidia,enable-hw-based-cs;
-				nvidia,rx-clk-tap-delay = <6>;
+				nvidia,cs-setup-clk-count = <0x1e>;
+				nvidia,cs-hold-clk-count = <0x1e>;
+				nvidia,rx-clk-tap-delay = <0x1f>;
+				nvidia,tx-clk-tap-delay = <0x0>;
 			};
 		};
 		spi@1 {
-- 
2.7.4