diff --git a/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-epcr7200.dts b/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-epcr7200.dts
index 8dccfdaf2..63d316a47 100755
--- a/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-epcr7200.dts
+++ b/hardware/nvidia/platform/t210/porg/kernel-dts/tegra210-epcr7200.dts
@@ -67,6 +67,828 @@
 			"",     "",     "SPI1_CS1",     "",     "",     "",     "",     "",     "",     "";
 	};
 
+	host1x {
+		vi_base: vi {
+			num-channels = <2>;
+			ports {
+				#address-cells = <1>;
+				#size-cells = <0>;
+				vi_port0: port@0 {
+					reg = <0>;
+					status = "okay";
+					cam_rbpcv2_imx219_vi_in0: endpoint {
+						port-index = <0>;
+						bus-width = <2>;
+						remote-endpoint = <&cam_rbpcv2_imx219_csi_out0>;
+					};
+				};
+				vi_port1: port@1 {
+					reg = <1>;
+					status = "okay";
+					cam_rbpcv2_imx219_vi_in1: endpoint {
+						port-index = <2>;
+						bus-width = <2>;
+						remote-endpoint = <&cam_rbpcv2_imx219_csi_out1>;
+					};
+				};
+			};
+		};
+
+		csi_base: nvcsi {
+			num-channels = <2>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			csi_chan0: channel@0 {
+				status = "okay";
+				reg = <0>;
+				ports {
+					#address-cells = <1>;
+					#size-cells = <0>;
+					csi_chan0_port0: port@0 {
+						reg = <0>;
+						status = "okay";
+						cam_rbpcv2_imx219_csi_in0: endpoint@0 {
+							port-index = <0>;
+							bus-width = <2>;
+							remote-endpoint = <&cam_rbpcv2_imx219_out0>;
+						};
+					};
+					csi_chan0_port1: port@1 {
+						reg = <1>;
+						status = "okay";
+						cam_rbpcv2_imx219_csi_out0: endpoint@1 {
+							remote-endpoint = <&cam_rbpcv2_imx219_vi_in0>;
+						};
+					};
+				};
+			};
+			csi_chan1: channel@1 {
+				status = "okay";
+				reg = <1>;
+				ports {
+					#address-cells = <1>;
+					#size-cells = <0>;
+					csi_chan1_port0: port@2 {
+						reg = <0>;
+						status = "okay";
+						cam_rbpcv2_imx219_csi_in1: endpoint@2 {
+							port-index = <2>;
+							bus-width = <2>;
+							remote-endpoint = <&cam_rbpcv2_imx219_out1>;
+						};
+					};
+					csi_chan1_port1: port@3 {
+						reg = <1>;
+						status = "okay";
+						cam_rbpcv2_imx219_csi_out1: endpoint@3 {
+							remote-endpoint = <&cam_rbpcv2_imx219_vi_in1>;
+						};
+					};
+				};
+			};
+		};
+		
+		#define CAM1_PWDN TEGRA_GPIO(S, 7)
+		#define CAM2_PWDN TEGRA_GPIO(T, 0)
+
+		i2c@546c0000 {
+		cam_i2c_mux: cam_i2c_mux@70 {
+			compatible = "nxp,pca9543";
+			reg = <0x70>;
+			#address-cells = <1>;
+			#size-cells = <0>;
+			vcc-pullup-supply = <&battery_reg>;
+			vcc-supply = <&p3509_vdd_3v3_cvb>;
+			status = "okay";
+
+			cmux_i2c_0:cmux_i2c_0@0 {
+				reg = <0>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				i2c-mux,deselect-on-exit;
+				cam_imx219_cam0: cam_rbpcv2_imx219_a@10 {
+					compatible = "nvidia,imx219";
+					/* I2C device address */
+					reg = <0x10>;
+
+					/* V4L2 device node location */
+					devnode = "video0";
+
+					/* Physical dimensions of sensor */
+					physical_w = "3.680";
+					physical_h = "2.760";
+
+					sensor_model = "imx219";
+
+					use_sensor_mode_id = "true";
+					reset-gpios = <&gpio CAM1_PWDN GPIO_ACTIVE_HIGH>;
+					/**
+					* ==== Modes ====
+					* A modeX node is required to support v4l2 driver
+					* implementation with NVIDIA camera software stack
+					*
+					* == Signal properties ==
+					*
+					* phy_mode = "";
+					* PHY mode used by the MIPI lanes for this device
+					*
+					* tegra_sinterface = "";
+					* CSI Serial interface connected to tegra
+					* Incase of virtual HW devices, use virtual
+					* For SW emulated devices, use host
+					*
+					* pix_clk_hz = "";
+					* Sensor pixel clock used for calculations like exposure and framerate
+					*
+					* readout_orientation = "0";
+					* Based on camera module orientation.
+					* Only change readout_orientation if you specifically
+					* Program a different readout order for this mode
+					*
+					* == Image format Properties ==
+					*
+					* active_w = "";
+					* Pixel active region width
+					*
+					* active_h = "";
+					* Pixel active region height
+					*
+					* pixel_t = "";
+					* The sensor readout pixel pattern
+					*
+					* line_length = "";
+					* Pixel line length (width) for sensor mode.
+					*
+					* == Source Control Settings ==
+					*
+					* Gain factor used to convert fixed point integer to float
+					* Gain range [min_gain/gain_factor, max_gain/gain_factor]
+					* Gain step [step_gain/gain_factor is the smallest step that can be configured]
+					* Default gain [Default gain to be initialized for the control.
+					*     use min_gain_val as default for optimal results]
+					* Framerate factor used to convert fixed point integer to float
+					* Framerate range [min_framerate/framerate_factor, max_framerate/framerate_factor]
+					* Framerate step [step_framerate/framerate_factor is the smallest step that can be configured]
+					* Default Framerate [Default framerate to be initialized for the control.
+					*     use max_framerate to get required performance]
+					* Exposure factor used to convert fixed point integer to float
+					* For convenience use 1 sec = 1000000us as conversion factor
+					* Exposure range [min_exp_time/exposure_factor, max_exp_time/exposure_factor]
+					* Exposure step [step_exp_time/exposure_factor is the smallest step that can be configured]
+					* Default Exposure Time [Default exposure to be initialized for the control.
+					*     Set default exposure based on the default_framerate for optimal exposure settings]
+					*
+					* gain_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_gain_val = ""; (ceil to integer)
+					* max_gain_val = ""; (ceil to integer)
+					* step_gain_val = ""; (ceil to integer)
+					* default_gain = ""; (ceil to integer)
+					* Gain limits for mode
+					*
+					* exposure_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_exp_time = ""; (ceil to integer)
+					* max_exp_time = ""; (ceil to integer)
+					* step_exp_time = ""; (ceil to integer)
+					* default_exp_time = ""; (ceil to integer)
+					* Exposure Time limits for mode (sec)
+					*
+					* framerate_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_framerate = ""; (ceil to integer)
+					* max_framerate = ""; (ceil to integer)
+					* step_framerate = ""; (ceil to integer)
+					* default_framerate = ""; (ceil to integer)
+					* Framerate limits for mode (fps)
+					*
+					* embedded_metadata_height = "";
+					* Sensor embedded metadata height in units of rows.
+					* If sensor does not support embedded metadata value should be 0.
+					*/
+					mode0 { /* IMX219_MODE_3264x2464_21FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_a";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "3264";
+						active_h = "2464";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "21000000"; /* 21.0 fps */
+						step_framerate = "1";
+						default_framerate = "21000000"; /* 21.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode1 { /* IMX219_MODE_3264x1848_28FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_a";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "3264";
+						active_h = "1848";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "28000000"; /* 28.0 fps */
+						step_framerate = "1";
+						default_framerate = "28000000"; /* 28.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode2 { /* IMX219_MODE_1920x1080_30FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_a";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1920";
+						active_h = "1080";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "30000000"; /* 30.0 fps */
+						step_framerate = "1";
+						default_framerate = "30000000"; /* 30.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+
+					mode3 { /* IMX219_MODE_1640x1232_30FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_a";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1640";
+						active_h = "1232";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "30000000"; /* 60.0 fps */
+						step_framerate = "1";
+						default_framerate = "30000000"; /* 60.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+
+					mode4 { /* IMX219_MODE_1280x720_60FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_a";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1280";
+						active_h = "720";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "60000000"; /* 60.0 fps */
+						step_framerate = "1";
+						default_framerate = "60000000"; /* 60.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					/*
+					*mode5 {  IMX219_MODE_1280x720_120FPS
+						* mclk_khz = "24000";
+						* num_lanes = "2";
+						* tegra_sinterface = "serial_a";
+						* phy_mode = "DPHY";
+						* discontinuous_clk = "yes";
+						* dpcm_enable = "false";
+						* cil_settletime = "0";
+
+						* active_w = "1280";
+						* active_h = "720";
+						* pixel_t = "bayer_rggb";
+						* readout_orientation = "90";
+						* line_length = "3560";
+						* inherent_gain = "1";
+						* mclk_multiplier = "9.33";
+						* pix_clk_hz = "169600000";
+
+						* gain_factor = "16";
+						* framerate_factor = "1000000";
+						* exposure_factor = "1000000";
+						* min_gain_val = "16"; // 1.00x
+						* max_gain_val = "170"; // 10.66x
+						* step_gain_val = "1";
+						* default_gain = "16"; // 1.00x
+						* min_hdr_ratio = "1";
+						* max_hdr_ratio = "1";
+						* min_framerate = "2000000"; // 2.0 fps
+						* max_framerate = "120000000"; // 120.0 fps
+						* step_framerate = "1";
+						* default_framerate = "120000000"; // 120.0 fps
+						* min_exp_time = "13"; // us
+						* max_exp_time = "683709"; // us
+						* step_exp_time = "1";
+						* default_exp_time = "2495"; // us
+
+						* embedded_metadata_height = "2";
+					*};
+					*/
+
+					ports {
+						#address-cells = <1>;
+						#size-cells = <0>;
+						port@0 {
+							reg = <0>;
+							cam_rbpcv2_imx219_out0: endpoint {
+								port-index = <0>;
+								bus-width = <2>;
+								remote-endpoint = <&cam_rbpcv2_imx219_csi_in0>;
+							};
+						};
+					};
+				};
+			};
+			cmux_i2c_1: cmux_i2c_1@1 {
+				reg = <1>;
+				#address-cells = <1>;
+				#size-cells = <0>;
+				i2c-mux,deselect-on-exit;
+				cam_imx219_cam1: cam_rbpcv2_imx219_c@10 {
+					compatible = "nvidia,imx219";
+					/* I2C device address */
+					reg = <0x10>;
+
+					/* V4L2 device node location */
+					devnode = "video1";
+
+					/* Physical dimensions of sensor */
+					physical_w = "3.680";
+					physical_h = "2.760";
+
+					sensor_model = "imx219";
+
+					use_sensor_mode_id = "true";
+					reset-gpios = <&gpio CAM2_PWDN GPIO_ACTIVE_HIGH>;
+					/**
+					* ==== Modes ====
+					* A modeX node is required to support v4l2 driver
+					* implementation with NVIDIA camera software stack
+					*
+					* == Signal properties ==
+					*
+					* phy_mode = "";
+					* PHY mode used by the MIPI lanes for this device
+					*
+					* tegra_sinterface = "";
+					* CSI Serial interface connected to tegra
+					* Incase of virtual HW devices, use virtual
+					* For SW emulated devices, use host
+					*
+					* pix_clk_hz = "";
+					* Sensor pixel clock used for calculations like exposure and framerate
+					*
+					* readout_orientation = "0";
+					* Based on camera module orientation.
+					* Only change readout_orientation if you specifically
+					* Program a different readout order for this mode
+					*
+					* == Image format Properties ==
+					*
+					* active_w = "";
+					* Pixel active region width
+					*
+					* active_h = "";
+					* Pixel active region height
+					*
+					* pixel_t = "";
+					* The sensor readout pixel pattern
+					*
+					* line_length = "";
+					* Pixel line length (width) for sensor mode.
+					*
+					* == Source Control Settings ==
+					*
+					* Gain factor used to convert fixed point integer to float
+					* Gain range [min_gain/gain_factor, max_gain/gain_factor]
+					* Gain step [step_gain/gain_factor is the smallest step that can be configured]
+					* Default gain [Default gain to be initialized for the control.
+					*     use min_gain_val as default for optimal results]
+					* Framerate factor used to convert fixed point integer to float
+					* Framerate range [min_framerate/framerate_factor, max_framerate/framerate_factor]
+					* Framerate step [step_framerate/framerate_factor is the smallest step that can be configured]
+					* Default Framerate [Default framerate to be initialized for the control.
+					*     use max_framerate to get required performance]
+					* Exposure factor used to convert fixed point integer to float
+					* For convenience use 1 sec = 1000000us as conversion factor
+					* Exposure range [min_exp_time/exposure_factor, max_exp_time/exposure_factor]
+					* Exposure step [step_exp_time/exposure_factor is the smallest step that can be configured]
+					* Default Exposure Time [Default exposure to be initialized for the control.
+					*     Set default exposure based on the default_framerate for optimal exposure settings]
+					*
+					* gain_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_gain_val = ""; (ceil to integer)
+					* max_gain_val = ""; (ceil to integer)
+					* step_gain_val = ""; (ceil to integer)
+					* default_gain = ""; (ceil to integer)
+					* Gain limits for mode
+					*
+					* exposure_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_exp_time = ""; (ceil to integer)
+					* max_exp_time = ""; (ceil to integer)
+					* step_exp_time = ""; (ceil to integer)
+					* default_exp_time = ""; (ceil to integer)
+					* Exposure Time limits for mode (sec)
+					*
+					* framerate_factor = ""; (integer factor used for floating to fixed point conversion)
+					* min_framerate = ""; (ceil to integer)
+					* max_framerate = ""; (ceil to integer)
+					* step_framerate = ""; (ceil to integer)
+					* default_framerate = ""; (ceil to integer)
+					* Framerate limits for mode (fps)
+					*
+					* embedded_metadata_height = "";
+					* Sensor embedded metadata height in units of rows.
+					* If sensor does not support embedded metadata value should be 0.
+					*/
+					mode0 { /* IMX219_MODE_3264x2464_21FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_c";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "3264";
+						active_h = "2464";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "21000000"; /* 21.0 fps */
+						step_framerate = "1";
+						default_framerate = "21000000"; /* 21.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode1 { /* IMX219_MODE_3264x1848_28FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_c";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "3264";
+						active_h = "1848";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "28000000"; /* 28.0 fps */
+						step_framerate = "1";
+						default_framerate = "28000000"; /* 28.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode2 { /* IMX219_MODE_1920x1080_30FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_c";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1920";
+						active_h = "1080";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "30000000"; /* 30.0 fps */
+						step_framerate = "1";
+						default_framerate = "30000000"; /* 30.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode3 { /* IMX219_MODE_1640x1232_30FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_c";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1640";
+						active_h = "1232";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "30000000"; /* 60.0 fps */
+						step_framerate = "1";
+						default_framerate = "30000000"; /* 60.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					mode4 { /* IMX219_MODE_1280x720_60FPS */
+						mclk_khz = "24000";
+						num_lanes = "2";
+						tegra_sinterface = "serial_c";
+						phy_mode = "DPHY";
+						discontinuous_clk = "yes";
+						dpcm_enable = "false";
+						cil_settletime = "0";
+
+						active_w = "1280";
+						active_h = "720";
+						pixel_t = "bayer_rggb";
+						readout_orientation = "90";
+						line_length = "3448";
+						inherent_gain = "1";
+						mclk_multiplier = "9.33";
+						pix_clk_hz = "182400000";
+
+						gain_factor = "16";
+						framerate_factor = "1000000";
+						exposure_factor = "1000000";
+						min_gain_val = "16"; /* 1.00x */
+						max_gain_val = "170"; /* 10.66x */
+						step_gain_val = "1";
+						default_gain = "16"; /* 1.00x */
+						min_hdr_ratio = "1";
+						max_hdr_ratio = "1";
+						min_framerate = "2000000"; /* 2.0 fps */
+						max_framerate = "60000000"; /* 60.0 fps */
+						step_framerate = "1";
+						default_framerate = "60000000"; /* 60.0 fps */
+						min_exp_time = "13"; /* us */
+						max_exp_time = "683709"; /* us */
+						step_exp_time = "1";
+						default_exp_time = "2495"; /* us */
+
+						embedded_metadata_height = "2";
+					};
+					/*
+					*mode5 { // IMX219_MODE_1280x720_120FPS
+					*	mclk_khz = "24000";
+					*	num_lanes = "2";
+					*	tegra_sinterface = "serial_c";
+					*	phy_mode = "DPHY";
+					*	discontinuous_clk = "yes";
+					*	dpcm_enable = "false";
+					*	cil_settletime = "0";
+
+					*	active_w = "1280";
+					*	active_h = "720";
+					*	pixel_t = "bayer_rggb";
+					*	readout_orientation = "90";
+					*	line_length = "3560";
+					*	inherent_gain = "1";
+					*	mclk_multiplier = "9.33";
+					*	pix_clk_hz = "169600000";
+
+					*	gain_factor = "16";
+					*	framerate_factor = "1000000";
+					*	exposure_factor = "1000000";
+					*	min_gain_val = "16"; // 1.00x
+					*	max_gain_val = "170"; // 10.66x
+					*	step_gain_val = "1";
+					*	default_gain = "16"; // 1.00x
+					*	min_hdr_ratio = "1";
+					*	max_hdr_ratio = "1";
+					*	min_framerate = "2000000"; // 2.0 fps
+					*	max_framerate = "120000000"; // 120.0 fps
+					*	step_framerate = "1";
+					*	default_framerate = "120000000"; // 120.0 fps
+					*	min_exp_time = "13"; // us
+					*	max_exp_time = "683709"; // us
+					*	step_exp_time = "1";
+					*	default_exp_time = "2495"; // us
+
+					*	embedded_metadata_height = "2";
+					*};
+					*/
+
+					ports {
+						#address-cells = <1>;
+						#size-cells = <0>;
+						port@0 {
+							reg = <0>;
+							cam_rbpcv2_imx219_out1: endpoint {
+								status = "okay";
+								port-index = <2>;
+								bus-width = <2>;
+								remote-endpoint = <&cam_rbpcv2_imx219_csi_in1>;
+							};
+						};
+					};
+				};
+			};
+		};
+	};
+	};
+
+	tegra-camera-platform {
+		modules {
+			cam_module0: module0 {
+				status = "okay";
+				cam_module0_drivernode0: drivernode0 {
+					status = "okay";
+					devname = "imx219 13-0010";
+					proc-device-tree = "/proc/device-tree/i2c@546c0000/cam_i2c_mux@70/cmux_i2c_0@0/cam_rbpcv2_imx219_a@10";
+				};
+				cam_module0_drivernode1: drivernode1 {
+					status = "okay";
+				};
+			};
+			cam_module1: module1 {
+				status = "okay";
+				cam_module1_drivernode0: drivernode0 {
+					status = "okay";
+					devname = "imx219 14-0010";
+					proc-device-tree = "/proc/device-tree/i2c@546c0000/cam_i2c_mux@70/cmux_i2c_1@1/cam_rbpcv2_imx219_c@10";
+				};
+				cam_module1_drivernode1: drivernode1 {
+					status = "okay";
+				};
+			};
+		};
+	};
+
 	#define GPIO_SDA TEGRA_GPIO(E, 7)
 	#define GPIO_SCK TEGRA_GPIO(Z, 2)
 
@@ -117,5 +939,12 @@
 			regulator-min-microvolt = <1800000>;
 			regulator-max-microvolt = <1800000>;
 		};
+		p3509_vdd_3v3_cvb: regulator@101 {
+			compatible = "regulator-fixed";
+			reg = <101>;
+			regulator-name = "vdd-3v3-cvb";
+			regulator-min-microvolt = <3300000>;
+			regulator-max-microvolt = <3300000>;
+		};
 	};
 };